<template>
  <nav class="doc-app__menu">
    <component :is="group.name && group?.collapsible !== false ? 'details' : 'div'"
               v-for="(group, id) in $mainMenu"
               :key="id"
               class="doc-app__menu__collapsible">
      <component :is="group.name && group?.collapsible !== false ? 'summary' : 'div'" v-if="group.name" class="-flex -gap">
        <rui-icon-text tag="h5"
                       class="-mvd -flex--grow"
                       :icon="group.icon"
                       :text="group.name" />
      </component>

      <rui-menu>
        <template v-for="entry in group.children" :key="entry.name">
          <rui-menu-item v-bind="linkParams(entry)">{{ entry.caption }}</rui-menu-item>
        </template>
      </rui-menu>
    </component>

    <details class="doc-app__menu__collapsible">
      <summary class="-flex -gap">
        <rui-icon-text tag="h5" class="-mvd -flex--grow" icon="doc:puzzle-piece" text="Components" />
      </summary>
      <rui-menu>
        <rui-search-form v-model="componentFilter" />
        <doc-component-menu-link v-for="component in componentsList" :key="component" :component-name="component" />
      </rui-menu>
    </details>
  </nav>
</template>

<script>
import DocComponentMenuLink from '../ComponentMenuLink/ComponentMenuLink.vue'

import { RuiIconText, RuiMenu, RuiMenuItem } from '../../../src/components/index.js'
import RuiSearchForm from '../../../src/components/Form/SearchForm.vue'

export default {
  name: 'DocAppMenu',
  components: { RuiIconText, RuiMenu, RuiMenuItem, RuiSearchForm, DocComponentMenuLink },
  data () {
    return {
      componentFilter: '',
    }
  },
  computed: {
    componentsList () {
      const filter = this.componentFilter.toLowerCase()
      return this.$docs.componentNames.filter(name => name.toLowerCase().includes(filter)).sort()
    },
  },
  methods: {
    linkParams (entry) {
      if (entry.to) return { href: entry.to }
      return {
        to: {
          name: entry.name,
          params: entry.params || {},
        },
      }
    },
  },
}
</script>
